#include "param.h"

float4   cnt    : register(c0);
sampler  t0     : register(s0);
sampler  t1     : register(s1);

float map(float3 p) {
  float t = 1000;
  for(int i = 0 ; i < OBJ_MAX; i++) {
    float4 o = tex2D(t1, float2(float(i)/OBJ_MAX, 0));
    if(o.w >= 1) {
      float3 g = o.xyz - p;
      t = min(t, length(g) - 0.5);
      //t = min(t, length(max(abs(g) - 0.5, 0)) - 0.01);
    }
  }
  p.z += cnt*2;
  float hunya = cos(p.x * 2) + cos(p.z * 2);
  t = min(dot( float3(0, 1, 0), p) + hunya * 0.2 + 0.1, t);
  return t;
}

float2 rot(float2 d, float a) {
  return float2(cos(a) * d.x - sin(a) * d.y, sin(a) * d.x + cos(a) * d.y);
}

float4 ps_main(float2 vp : vpos) : color {
  float3 d    = normalize(float3(-vp + float2(SCRX_H, SCRY_H), SCRY_H)/SCRY_H);
  float  angle = 0.8;
  d.yz = rot(d.yz, angle);
  d.xy = rot(d.xy, -0.1);
  float3 pos    = float3(0, 2.5, -5);
  float3 ro     = pos;
  
  //go
  for(int i = 0 ; i < 50; i++, pos += map(pos) * d);
  return float4(length(pos - ro ) * 0.03 + map(pos + normalize(float3(2,1,1)) * 0.2) + d.xzz * 0.2, 1);
}

float4 ps_main_f(float2 vp : vpos, float2 uv : texcoord0) : color {
  float4 argb = tex2D(t0, uv);
  float2 d = float2(0.001, 0);
  argb += tex2D(t0, uv + d.xy);
  argb += tex2D(t0, uv - d.xy);
  argb += tex2D(t0, uv + d.yx);
  argb += tex2D(t0, uv - d.yx);
  return argb / 5;
}


